unit testhide;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus, Grids, Tlhelp32, Placemnt;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    RefreshButton: TButton;
    PopupMenu1: TPopupMenu;
    ExitButton: TButton;
    ShowSelected1: TMenuItem;
    CloseSlected1: TMenuItem;
    RefreshWindows1: TMenuItem;
    CloseProgran1: TMenuItem;
    WindowOps: TPanel;
    CloseButton: TButton;
    ShowButton: TButton;
    MinButton: TButton;
    MoveButton: TButton;
    Label1: TLabel;
    Xpos: TEdit;
    Label2: TLabel;
    YPos: TEdit;
    StringGrid1: TStringGrid;
    HeaderControl1: THeaderControl;
    FormStorage1: TFormStorage;
    Image2: TImage;
    Image1: TImage;
    procedure CloseButtonClick(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure RefreshButtonClick(Sender: TObject);
    procedure ShowButtonClick(Sender: TObject);
    procedure MinButtonClick(Sender: TObject);
    procedure MoveButtonClick(Sender: TObject);
    procedure XposKeyPress(Sender: TObject; var Key: Char);
    procedure XposChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure HeaderControl1SectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
  private
    isemptylist: boolean;
    procedure clearObjects;
    function LookForExe(TheHandle: THandle): string;
    function GetWindowExecutableFilename(Wnd: hWnd): string;
    { Private declarations }
  public
    { Public declarations }
  end;

  WindowClass = class(Tobject)          // holds the bitmap and window handle informations
    XWnd: hwnd;
    MyBitmap: TBitmap;
  end;

  EMoveException = class(Exception)
  end;
(********************************************************************************************)

var
  Form1: TForm1;
(********************************************************************************************)

implementation
(********************************************************************************************)

{$R *.DFM}

(***********************************************************************************)

procedure TForm1.clearObjects;
// empty the stringgrid of all its objects
var x: integer;
begin
  for x := 0 to stringgrid1.RowCount - 1 do
    if stringgrid1.Objects[0, x] <> nil then // objects are only stored in the first row
    begin
      stringgrid1.Objects[0, x].free;
      stringgrid1.Objects[0, x] := nil;
    end;
end;
(***********************************************************************************)

procedure TForm1.Close1Click(Sender: TObject);
begin
  isemptylist := true;
  clearObjects;
  application.terminate;
end;
(***********************************************************************************)

function enumwindowsproc(thisWnd: hwnd; lparam: Tform1): boolean; stdcall;
//event triggered when a window is found by EnumWindows API call
var windowsstr: pchar;                  // window title
  Thisrec: WindowClass;                 // other window information (bitmap and handle)
  tempstr: string;
begin
  enumwindowsproc := false;
  thisrec := windowClass.create;
  if iswindow(thiswnd) then
  begin
    windowsstr := stralloc(255);
    getwindowtext(thiswnd, windowsstr, 255); // get window title
    tempstr := string(windowsstr);
    strdispose(windowsstr);
    if length(tempstr) = 0 then
    begin
      tempstr := ' < No window title >'; // assign image for titled windows
      thisrec.MyBitmap := form1.image2.Picture.Bitmap;
    end
    else                                // assign image for untitled windows
      thisrec.MyBitmap := form1.image1.Picture.Bitmap;
    thisrec.xwnd := thiswnd;            // assign window handle
    with lparam.stringgrid1 do
    begin
      Cols[0].addobject(tempstr, thisrec); // add object and title to the grid
      Cols[1].add(inttostr(thiswnd));   // add additional information to the grid
      Cols[2].add(extractfilename(lparam.getWindowExecutableFilename(thiswnd)));
      RowCount := rowCount + 1;         // add a new row
    end;
    enumwindowsproc := true;
  end;
end;
(***********************************************************************************)

procedure TForm1.RefreshButtonClick(Sender: TObject);
begin
  IsemptyList := true;
  stringgrid1.cols[0].BeginUpdate;      // lock the grid before changing anything
  stringgrid1.cols[1].BeginUpdate;
  stringgrid1.cols[2].BeginUpdate;
  clearObjects;                         // empty all previous objects (if any)
  stringgrid1.cols[0].clear;
  stringgrid1.cols[1].clear;
  stringgrid1.cols[2].clear;
  stringgrid1.rowcount := 0;
  enumwindows(@enumwindowsproc, longint(form1)); // get the window list from Windows
  Windowops.enabled := true;
  if length(stringgrid1.cells[1, stringgrid1.rowcount - 1]) = 0 then // if last item is blank
    stringgrid1.rowcount := stringgrid1.rowcount - 1; // then remove it
  stringgrid1.cols[0].EndUpdate;        // unlock the grid after all updates
  stringgrid1.cols[1].EndUpdate;
  stringgrid1.cols[2].EndUpdate;
  IsemptyList := false;
  stringgrid1.SetFocus;
end;
(***********************************************************************************)

procedure TForm1.CloseButtonClick(Sender: TObject);
var mywnd: hwnd;
  oldPos: integer;
  donewindow: boolean;
  error: integer;
begin
  mywnd := windowClass(stringgrid1.cols[0].objects[stringgrid1.row]).Xwnd;
  donewindow := closewindow(mywnd);     // call Windows API to close the selected window
  error := getlasterror;
  if donewindow then
     begin
       stringgrid1.cols[0].BeginUpdate;      // lock the grid before changing anything
       stringgrid1.cols[1].BeginUpdate;
       stringgrid1.cols[2].BeginUpdate;
       oldPos := stringgrid1.Row;            // save old cursor position
       refreshbutton.click;                  // refresh the window list
       if oldPos > 0 then                    // restore cursor position
          stringgrid1.row := oldPos - 1
       else
          stringgrid1.row := 0;
       stringgrid1.cols[0].EndUpdate;        // unlock the grid after all updates
       stringgrid1.cols[1].EndUpdate;
       stringgrid1.cols[2].EndUpdate;
     end
  else
     showmessage('There was a problem closeing the selected window. Error code : ' +
                 inttostr(error));
end;
(***********************************************************************************)

procedure TForm1.ShowButtonClick(Sender: TObject); // unhides the selected window
var mywnd: hwnd;
begin
  mywnd := WindowClass(stringgrid1.objects[0, stringgrid1.row]).xWnd;
  showwindow(mywnd, sw_show);
end;
(***********************************************************************************)

procedure TForm1.MinButtonClick(Sender: TObject); // minimizes the selected window
var mywnd: hwnd;
begin
  mywnd := WindowClass(stringgrid1.objects[0, stringgrid1.row]).xWnd;
  sendmessage(mywnd, wm_syscommand, sc_minimize, 0);
end;
(***********************************************************************************)

procedure TForm1.MoveButtonClick(Sender: TObject); // moves the selected window to
var mywnd : hwnd;                                  // the user specified screen coordinates
    error : integer;
    WinRect : TRect;
begin
  mywnd := WindowClass(stringgrid1.objects[0, stringgrid1.row]).xWnd;
  GetWindowRect(mywnd,winrect);
  try
    movewindow(mywnd, strtoint(Xpos.text), strtoint(YPos.text),
               winrect.right - winrect.left, winrect.Bottom - winrect.Top, true);
    error := getlasterror;
    if not (error in[0, 87]) then        // error 87 seems to occurr in all moving cases
       raise EmoveException.create('');  // so I just excluded it here
  except
     MessageDlg('An error ocurred while trying to move the selected window',
                mtError, [mbOK], 0);
  end;
end;
(***********************************************************************************)

procedure TForm1.XposKeyPress(Sender: TObject; var Key: Char); // rejects all non-numeric
begin                                                          // characters
  if not (key in ['0'..'9', #8, '-']) then
    abort;
end;
(***********************************************************************************)

procedure TForm1.XposChange(Sender: TObject);    // disables the move button
begin                                            // if no acceptable coordinates are entered
  movebutton.enabled := (length(Xpos.text) <> 0) and (length(YPos.text) <> 0);
end;
(***********************************************************************************)

procedure TForm1.FormCreate(Sender: TObject);
begin
  Isemptylist := true;                           // match the colum widths on the stringgrid
                                                 // with the size of the header
  stringgrid1.Colwidths[0] := headercontrol1.Sections.Items[0].width;
  stringgrid1.Colwidths[1] := headercontrol1.Sections.Items[1].width;
  stringgrid1.Colwidths[2] := headercontrol1.Sections.Items[2].width;
end;
(***********************************************************************************)

procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
// handles the drawing of cells in the string grid
var bitmap   : Tbitmap;
    offset   : integer;
    transcol : Tcolor;
    destrect,
    srcrect  : Trect;
    oldbrcol,
    oldfntcol: tcolor;
begin
  oldbrcol := (sender as tstringgrid).canvas.brush.color;  // save old brush and font attributes
  oldfntcol := (sender as tstringgrid).canvas.font.color;
  if gdselected in state then                              // handle selected cells 
  begin
    (sender as tstringgrid).canvas.brush.color := clhighlight;    // assign highlight attributes
    (sender as tstringgrid).canvas.font.color := clhighlighttext; // for the font and brush
  end;
  (sender as tstringgrid).canvas.fillrect(rect);           // clear out the cell rectangle
  // Handle the first column first (window title)
  if (Acol = 0) and (not isemptylist) then                 // if there is anything to draw
    if length((sender as Tstringgrid).cells[0, Arow]) <> 0 then  // if the title is non-blank
    begin
      transcol := clwhite;                 // transparent color (depend on the bitmap used)
      offset := 2;                         // where to start drawing on the cell
      // get the bitmap from tha associated object in the string grid
      Bitmap := TBitmap(WindowClass((sender as Tstringgrid).Objects[0, Arow]).Mybitmap);
      if Bitmap <> nil then
      begin
        // get original bitmap bounding rectangle
        srcrect := Bounds(0, 0, Bitmap.Width, Bitmap.Height);
        // get destination bitmap bounding rectangle
        destrect := Bounds(Rect.Left + 2, Rect.Top, Bitmap.Width, Bitmap.Height);
        // draw the bitmap on the cell's canvas using transparency (transcol)
        (sender as tstringgrid).canvas.BrushCopy(destrect, Bitmap, srcrect, TransCol);
        // recalculate the drawing offset (to draw text past the bitmap)
        Offset := Bitmap.width + 16;
      end;
      with (sender as tstringgrid) do
        canvas.TextOut(Rect.Left + Offset, Rect.Top, cells[0, aRow]); // draw the text 
    end;
  // handle the rest of the columns (only simple text drawing this time)
  with (sender as tstringgrid) do
    case acol of
      1: canvas.TextOut(Rect.Left + 30, Rect.Top, format('%8s', [cells[acol, aRow]]));
      2: canvas.TextOut(Rect.Left, Rect.Top, cells[acol, aRow])
    end;
  (sender as tstringgrid).canvas.brush.color := oldbrcol; // restore old brush and
  (sender as tstringgrid).canvas.font.color := oldfntcol; // font attributes
end;
(***********************************************************************************)

function TForm1.GetWindowExecutableFilename(Wnd: hWnd): string;
var                            // get the executable file that owns the given window
  ProcessID: DWORD;
begin
  GetWindowThreadProcessId(Wnd, @ProcessID);
  result := lookforexe(ProcessID)
end;
(***********************************************************************************)

procedure TForm1.HeaderControl1SectionResize(HeaderControl: THeaderControl;
  Section: THeaderSection); // resizes the grid's columns to match the header
begin
  stringgrid1.Colwidths[Section.index] := section.Width;
end;
(***********************************************************************************)

function Tform1.LookForExe(TheHandle: THandle): string;
var                                   // searches for a particular process in the
  Proc: TProcessEntry32;              // list of running processes
  Snap: THandle;
  tempname: string;
  found: boolean;
begin
  try
    found := false;
    Snap := CreateToolHelp32SnapShot(TH32CS_SNAPALL, 0); // API calls. Picked from
    Proc.dwSize := SizeOf(TProcessEntry32);              // someone on the Borland NG's
    Process32First(Snap, Proc);                          // Sorry ... forgot the name.
    repeat
      if proc.th32ProcessID = thehandle then
      begin
        if length(string(Proc.szExeFile)) > 0 then
          tempname := proc.szExeFile
        else
          tempname := '< Unknown >';
        found := true;
      end;
    until (not Process32Next(Snap, Proc)) or found;
  except
    showmessage('Can not determine executable name for this process');
  end;
  result := tempname;
end;
(********************************************************************************************)
end.

